/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.81.8
        Device            :  PIC16F1825
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include "PWM_pattern_data.h"

uint16_t tmr1_reload_value;

void TMR1_ISR(void)
{
    static uint16_t i_pattern = 0;           // PWMp^[f[^̗vfԍ
        
    if(i_pattern == 0){
        LATAbits.LATA5 = 1;                 // |[gA51o͂Dwߓd1Ԃ̏vԃj^p
    }

    PIR1bits.TMR1IF = 0;                    // Clear the TMR1 interrupt flag
    
    TMR1_WriteTimer(tmr1_reload_value);     // ^C}1ɃJEgAbvl̍Ċi[  I[ot[ōĊ荞

    LATC = PWM_pattern_data[i_pattern++];   // PWMp^[M|[gC0, C1, C2ɏo
    
    if(i_pattern >= 972){                   // dwߒl1ŁCvfԍZbg
        i_pattern = 0;
    }

	LATAbits.LATA5 = 0;                     // |[gA50o͂D
}

void main(void)
{
    unsigned int T1INT_com;
    unsigned int T1INT_set;
    
    // initialize the device
    SYSTEM_Initialize();

    while (1)
    {
        T1INT_com = ADC_GetConversion(0x07);		// AN7(7ԃs)w  ^C}1荞ݎwߒl̓ǂݍ
                                                    // T1INT_com(min) = 0x0, T1INT_com(max) = 0xFFC0
        if(T1INT_com < 0xD000){                     // ΂̍]𒲐ϒR̊px͈͂gHv
            T1INT_set = (T1INT_com >>3) + 0x0C00;   // ̊荞ݎil0x0C00ɂT1INTmin=102us(fmax=10Hz)j
        }else{
            T1INT_set = T1INT_com;                  // ᑬ̊荞ݎifmax=0.5Hzj
        }

        tmr1_reload_value = 0xFFFF - T1INT_set + 1;  // ^C}1荞ݎݒ(JEgAbvEI[ot[Ŋ荞)
    }
}
/**
 End of File
*/